diff -ruN ccp4srs-old/build-aux/missing ccp4srs/build-aux/missing
--- ccp4srs-old/build-aux/missing	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/build-aux/missing	2014-09-09 21:34:12.000000000 -0700
@@ -1,11 +1,10 @@
 #! /bin/sh
-# Common stub for a few missing GNU programs while installing.
+# Common wrapper for a few potentially missing GNU programs.
 
-scriptversion=2009-04-28.21; # UTC
+scriptversion=2012-06-26.16; # UTC
 
-# Copyright (C) 1996, 1997, 1999, 2000, 2002, 2003, 2004, 2005, 2006,
-# 2008, 2009 Free Software Foundation, Inc.
-# Originally by Fran,cois Pinard <pinard@iro.umontreal.ca>, 1996.
+# Copyright (C) 1996-2013 Free Software Foundation, Inc.
+# Originally written by Fran,cois Pinard <pinard@iro.umontreal.ca>, 1996.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,69 +25,40 @@
 # the same distribution terms that you use for the rest of that program.
 
 if test $# -eq 0; then
-  echo 1>&2 "Try \`$0 --help' for more information"
+  echo 1>&2 "Try '$0 --help' for more information"
   exit 1
 fi
 
-run=:
-sed_output='s/.* --output[ =]\([^ ]*\).*/\1/p'
-sed_minuso='s/.* -o \([^ ]*\).*/\1/p'
-
-# In the cases where this matters, `missing' is being run in the
-# srcdir already.
-if test -f configure.ac; then
-  configure_ac=configure.ac
-else
-  configure_ac=configure.in
-fi
+case $1 in
 
-msg="missing on your system"
+  --is-lightweight)
+    # Used by our autoconf macros to check whether the available missing
+    # script is modern enough.
+    exit 0
+    ;;
 
-case $1 in
---run)
-  # Try to run requested program, and just exit if it succeeds.
-  run=
-  shift
-  "$@" && exit 0
-  # Exit code 63 means version mismatch.  This often happens
-  # when the user try to use an ancient version of a tool on
-  # a file that requires a minimum version.  In this case we
-  # we should proceed has if the program had been absent, or
-  # if --run hadn't been passed.
-  if test $? = 63; then
-    run=:
-    msg="probably too old"
-  fi
-  ;;
+  --run)
+    # Back-compat with the calling convention used by older automake.
+    shift
+    ;;
 
   -h|--h|--he|--hel|--help)
     echo "\
 $0 [OPTION]... PROGRAM [ARGUMENT]...
 
-Handle \`PROGRAM [ARGUMENT]...' for when PROGRAM is missing, or return an
-error status if there is no known handling for PROGRAM.
+Run 'PROGRAM [ARGUMENT]...', returning a proper advice when this fails due
+to PROGRAM being missing or too old.
 
 Options:
   -h, --help      display this help and exit
   -v, --version   output version information and exit
-  --run           try to run the given command, and emulate it if it fails
 
 Supported PROGRAM values:
-  aclocal      touch file \`aclocal.m4'
-  autoconf     touch file \`configure'
-  autoheader   touch file \`config.h.in'
-  autom4te     touch the output file, or create a stub one
-  automake     touch all \`Makefile.in' files
-  bison        create \`y.tab.[ch]', if possible, from existing .[ch]
-  flex         create \`lex.yy.c', if possible, from existing .c
-  help2man     touch the output file
-  lex          create \`lex.yy.c', if possible, from existing .c
-  makeinfo     touch the output file
-  tar          try tar, gnutar, gtar, then tar without non-portable flags
-  yacc         create \`y.tab.[ch]', if possible, from existing .[ch]
+  aclocal   autoconf  autoheader   autom4te  automake  makeinfo
+  bison     yacc      flex         lex       help2man
 
-Version suffixes to PROGRAM as well as the prefixes \`gnu-', \`gnu', and
-\`g' are ignored when checking the name.
+Version suffixes to PROGRAM as well as the prefixes 'gnu-', 'gnu', and
+'g' are ignored when checking the name.
 
 Send bug reports to <bug-automake@gnu.org>."
     exit $?
@@ -100,272 +70,141 @@
     ;;
 
   -*)
-    echo 1>&2 "$0: Unknown \`$1' option"
-    echo 1>&2 "Try \`$0 --help' for more information"
+    echo 1>&2 "$0: unknown '$1' option"
+    echo 1>&2 "Try '$0 --help' for more information"
     exit 1
     ;;
 
 esac
 
-# normalize program name to check for.
-program=`echo "$1" | sed '
-  s/^gnu-//; t
-  s/^gnu//; t
-  s/^g//; t'`
-
-# Now exit if we have it, but it failed.  Also exit now if we
-# don't have it and --version was passed (most likely to detect
-# the program).  This is about non-GNU programs, so use $1 not
-# $program.
-case $1 in
-  lex*|yacc*)
-    # Not GNU programs, they don't have --version.
-    ;;
-
-  tar*)
-    if test -n "$run"; then
-       echo 1>&2 "ERROR: \`tar' requires --run"
-       exit 1
-    elif test "x$2" = "x--version" || test "x$2" = "x--help"; then
-       exit 1
-    fi
-    ;;
+# Run the given program, remember its exit status.
+"$@"; st=$?
 
-  *)
-    if test -z "$run" && ($1 --version) > /dev/null 2>&1; then
-       # We have it, but it failed.
-       exit 1
-    elif test "x$2" = "x--version" || test "x$2" = "x--help"; then
-       # Could not run --version or --help.  This is probably someone
-       # running `$TOOL --version' or `$TOOL --help' to check whether
-       # $TOOL exists and not knowing $TOOL uses missing.
-       exit 1
-    fi
-    ;;
-esac
-
-# If it does not exist, or fails to run (possibly an outdated version),
-# try to emulate it.
-case $program in
-  aclocal*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`acinclude.m4' or \`${configure_ac}'.  You might want
-         to install the \`Automake' and \`Perl' packages.  Grab them from
-         any GNU archive site."
-    touch aclocal.m4
-    ;;
-
-  autoconf*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`${configure_ac}'.  You might want to install the
-         \`Autoconf' and \`GNU m4' packages.  Grab them from any GNU
-         archive site."
-    touch configure
-    ;;
-
-  autoheader*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`acconfig.h' or \`${configure_ac}'.  You might want
-         to install the \`Autoconf' and \`GNU m4' packages.  Grab them
-         from any GNU archive site."
-    files=`sed -n 's/^[ ]*A[CM]_CONFIG_HEADER(\([^)]*\)).*/\1/p' ${configure_ac}`
-    test -z "$files" && files="config.h"
-    touch_files=
-    for f in $files; do
-      case $f in
-      *:*) touch_files="$touch_files "`echo "$f" |
-				       sed -e 's/^[^:]*://' -e 's/:.*//'`;;
-      *) touch_files="$touch_files $f.in";;
-      esac
-    done
-    touch $touch_files
-    ;;
-
-  automake*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified \`Makefile.am', \`acinclude.m4' or \`${configure_ac}'.
-         You might want to install the \`Automake' and \`Perl' packages.
-         Grab them from any GNU archive site."
-    find . -type f -name Makefile.am -print |
-	   sed 's/\.am$/.in/' |
-	   while read f; do touch "$f"; done
-    ;;
+# If it succeeded, we are done.
+test $st -eq 0 && exit 0
 
-  autom4te*)
-    echo 1>&2 "\
-WARNING: \`$1' is needed, but is $msg.
-         You might have modified some files without having the
-         proper tools for further handling them.
-         You can get \`$1' as part of \`Autoconf' from any GNU
-         archive site."
-
-    file=`echo "$*" | sed -n "$sed_output"`
-    test -z "$file" && file=`echo "$*" | sed -n "$sed_minuso"`
-    if test -f "$file"; then
-	touch $file
-    else
-	test -z "$file" || exec >$file
-	echo "#! /bin/sh"
-	echo "# Created by GNU Automake missing as a replacement of"
-	echo "#  $ $@"
-	echo "exit 0"
-	chmod +x $file
-	exit 1
-    fi
-    ;;
-
-  bison*|yacc*)
-    echo 1>&2 "\
-WARNING: \`$1' $msg.  You should only need it if
-         you modified a \`.y' file.  You may need the \`Bison' package
-         in order for those modifications to take effect.  You can get
-         \`Bison' from any GNU archive site."
-    rm -f y.tab.c y.tab.h
-    if test $# -ne 1; then
-        eval LASTARG="\${$#}"
-	case $LASTARG in
-	*.y)
-	    SRCFILE=`echo "$LASTARG" | sed 's/y$/c/'`
-	    if test -f "$SRCFILE"; then
-	         cp "$SRCFILE" y.tab.c
-	    fi
-	    SRCFILE=`echo "$LASTARG" | sed 's/y$/h/'`
-	    if test -f "$SRCFILE"; then
-	         cp "$SRCFILE" y.tab.h
-	    fi
-	  ;;
-	esac
-    fi
-    if test ! -f y.tab.h; then
-	echo >y.tab.h
-    fi
-    if test ! -f y.tab.c; then
-	echo 'main() { return 0; }' >y.tab.c
-    fi
-    ;;
-
-  lex*|flex*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified a \`.l' file.  You may need the \`Flex' package
-         in order for those modifications to take effect.  You can get
-         \`Flex' from any GNU archive site."
-    rm -f lex.yy.c
-    if test $# -ne 1; then
-        eval LASTARG="\${$#}"
-	case $LASTARG in
-	*.l)
-	    SRCFILE=`echo "$LASTARG" | sed 's/l$/c/'`
-	    if test -f "$SRCFILE"; then
-	         cp "$SRCFILE" lex.yy.c
-	    fi
-	  ;;
-	esac
-    fi
-    if test ! -f lex.yy.c; then
-	echo 'main() { return 0; }' >lex.yy.c
-    fi
-    ;;
-
-  help2man*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-	 you modified a dependency of a manual page.  You may need the
-	 \`Help2man' package in order for those modifications to take
-	 effect.  You can get \`Help2man' from any GNU archive site."
-
-    file=`echo "$*" | sed -n "$sed_output"`
-    test -z "$file" && file=`echo "$*" | sed -n "$sed_minuso"`
-    if test -f "$file"; then
-	touch $file
-    else
-	test -z "$file" || exec >$file
-	echo ".ab help2man is required to generate this page"
-	exit $?
-    fi
-    ;;
-
-  makeinfo*)
-    echo 1>&2 "\
-WARNING: \`$1' is $msg.  You should only need it if
-         you modified a \`.texi' or \`.texinfo' file, or any other file
-         indirectly affecting the aspect of the manual.  The spurious
-         call might also be the consequence of using a buggy \`make' (AIX,
-         DU, IRIX).  You might want to install the \`Texinfo' package or
-         the \`GNU make' package.  Grab either from any GNU archive site."
-    # The file to touch is that specified with -o ...
-    file=`echo "$*" | sed -n "$sed_output"`
-    test -z "$file" && file=`echo "$*" | sed -n "$sed_minuso"`
-    if test -z "$file"; then
-      # ... or it is the one specified with @setfilename ...
-      infile=`echo "$*" | sed 's/.* \([^ ]*\) *$/\1/'`
-      file=`sed -n '
-	/^@setfilename/{
-	  s/.* \([^ ]*\) *$/\1/
-	  p
-	  q
-	}' $infile`
-      # ... or it is derived from the source name (dir/f.texi becomes f.info)
-      test -z "$file" && file=`echo "$infile" | sed 's,.*/,,;s,.[^.]*$,,'`.info
-    fi
-    # If the file does not exist, the user really needs makeinfo;
-    # let's fail without touching anything.
-    test -f $file || exit 1
-    touch $file
-    ;;
-
-  tar*)
-    shift
-
-    # We have already tried tar in the generic part.
-    # Look for gnutar/gtar before invocation to avoid ugly error
-    # messages.
-    if (gnutar --version > /dev/null 2>&1); then
-       gnutar "$@" && exit 0
-    fi
-    if (gtar --version > /dev/null 2>&1); then
-       gtar "$@" && exit 0
-    fi
-    firstarg="$1"
-    if shift; then
-	case $firstarg in
-	*o*)
-	    firstarg=`echo "$firstarg" | sed s/o//`
-	    tar "$firstarg" "$@" && exit 0
-	    ;;
-	esac
-	case $firstarg in
-	*h*)
-	    firstarg=`echo "$firstarg" | sed s/h//`
-	    tar "$firstarg" "$@" && exit 0
-	    ;;
-	esac
-    fi
-
-    echo 1>&2 "\
-WARNING: I can't seem to be able to run \`tar' with the given arguments.
-         You may want to install GNU tar or Free paxutils, or check the
-         command line arguments."
-    exit 1
-    ;;
-
-  *)
-    echo 1>&2 "\
-WARNING: \`$1' is needed, and is $msg.
-         You might have modified some files without having the
-         proper tools for further handling them.  Check the \`README' file,
-         it often tells you about the needed prerequisites for installing
-         this package.  You may also peek at any GNU archive site, in case
-         some other package would contain this missing \`$1' program."
-    exit 1
-    ;;
-esac
+# Also exit now if we it failed (or wasn't found), and '--version' was
+# passed; such an option is passed most likely to detect whether the
+# program is present and works.
+case $2 in --version|--help) exit $st;; esac
+
+# Exit code 63 means version mismatch.  This often happens when the user
+# tries to use an ancient version of a tool on a file that requires a
+# minimum version.
+if test $st -eq 63; then
+  msg="probably too old"
+elif test $st -eq 127; then
+  # Program was missing.
+  msg="missing on your system"
+else
+  # Program was found and executed, but failed.  Give up.
+  exit $st
+fi
 
-exit 0
+perl_URL=http://www.perl.org/
+flex_URL=http://flex.sourceforge.net/
+gnu_software_URL=http://www.gnu.org/software
+
+program_details ()
+{
+  case $1 in
+    aclocal|automake)
+      echo "The '$1' program is part of the GNU Automake package:"
+      echo "<$gnu_software_URL/automake>"
+      echo "It also requires GNU Autoconf, GNU m4 and Perl in order to run:"
+      echo "<$gnu_software_URL/autoconf>"
+      echo "<$gnu_software_URL/m4/>"
+      echo "<$perl_URL>"
+      ;;
+    autoconf|autom4te|autoheader)
+      echo "The '$1' program is part of the GNU Autoconf package:"
+      echo "<$gnu_software_URL/autoconf/>"
+      echo "It also requires GNU m4 and Perl in order to run:"
+      echo "<$gnu_software_URL/m4/>"
+      echo "<$perl_URL>"
+      ;;
+  esac
+}
+
+give_advice ()
+{
+  # Normalize program name to check for.
+  normalized_program=`echo "$1" | sed '
+    s/^gnu-//; t
+    s/^gnu//; t
+    s/^g//; t'`
+
+  printf '%s\n' "'$1' is $msg."
+
+  configure_deps="'configure.ac' or m4 files included by 'configure.ac'"
+  case $normalized_program in
+    autoconf*)
+      echo "You should only need it if you modified 'configure.ac',"
+      echo "or m4 files included by it."
+      program_details 'autoconf'
+      ;;
+    autoheader*)
+      echo "You should only need it if you modified 'acconfig.h' or"
+      echo "$configure_deps."
+      program_details 'autoheader'
+      ;;
+    automake*)
+      echo "You should only need it if you modified 'Makefile.am' or"
+      echo "$configure_deps."
+      program_details 'automake'
+      ;;
+    aclocal*)
+      echo "You should only need it if you modified 'acinclude.m4' or"
+      echo "$configure_deps."
+      program_details 'aclocal'
+      ;;
+   autom4te*)
+      echo "You might have modified some maintainer files that require"
+      echo "the 'automa4te' program to be rebuilt."
+      program_details 'autom4te'
+      ;;
+    bison*|yacc*)
+      echo "You should only need it if you modified a '.y' file."
+      echo "You may want to install the GNU Bison package:"
+      echo "<$gnu_software_URL/bison/>"
+      ;;
+    lex*|flex*)
+      echo "You should only need it if you modified a '.l' file."
+      echo "You may want to install the Fast Lexical Analyzer package:"
+      echo "<$flex_URL>"
+      ;;
+    help2man*)
+      echo "You should only need it if you modified a dependency" \
+           "of a man page."
+      echo "You may want to install the GNU Help2man package:"
+      echo "<$gnu_software_URL/help2man/>"
+    ;;
+    makeinfo*)
+      echo "You should only need it if you modified a '.texi' file, or"
+      echo "any other file indirectly affecting the aspect of the manual."
+      echo "You might want to install the Texinfo package:"
+      echo "<$gnu_software_URL/texinfo/>"
+      echo "The spurious makeinfo call might also be the consequence of"
+      echo "using a buggy 'make' (AIX, DU, IRIX), in which case you might"
+      echo "want to install GNU make:"
+      echo "<$gnu_software_URL/make/>"
+      ;;
+    *)
+      echo "You might have modified some files without having the proper"
+      echo "tools for further handling them.  Check the 'README' file, it"
+      echo "often tells you about the needed prerequisites for installing"
+      echo "this package.  You may also peek at any GNU archive site, in"
+      echo "case some other package contains this missing '$1' program."
+      ;;
+  esac
+}
+
+give_advice "$1" | sed -e '1s/^/WARNING: /' \
+                       -e '2,$s/^/         /' >&2
+
+# Propagate the correct exit status (expected to be 127 for a program
+# not found, 63 for a program that failed due to version mismatch).
+exit $st
 
 # Local variables:
 # eval: (add-hook 'write-file-hooks 'time-stamp)
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_angle.cpp ccp4srs/ccp4srs/ccp4srs_angle.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_angle.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_angle.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_angle.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_angle.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_angle  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSAngle  - angle restraint class
+//  **** Classes :  ccp4srs::Angle  - angle restraint class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -39,105 +39,107 @@
 #include "ccp4srs_angle.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSAngle::CCP4SRSAngle()  {
-  atom_1    = -1;
-  atom_2    = -1;
-  atom_3    = -1;
-  angle     = 0.0;
-  angle_esd = 0.0;
-}
-
-CCP4SRSAngle::~CCP4SRSAngle()  {
-}
-
-
-int CCP4SRSAngle::readFromCIF ( PCMMCIFLoop mmCIFLoop, int angleNo,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-int rc;
-
-  rc = 0;
-
-  get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
-                      angleNo,atoms,rc );
-  get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
-                      angleNo,atoms,rc );
-  get_atom_from_cif ( atom_3,mmCIFLoop,MMCIF_TAG_ATOM_ID_3,
-                      angleNo,atoms,rc );
-
-  mmCIFLoop->CopyReal(angle    ,MMCIF_TAG_VALUE_ANGLE    ,angleNo,rc);
-  mmCIFLoop->CopyReal(angle_esd,MMCIF_TAG_VALUE_ANGLE_ESD,angleNo,rc);
-
-  return rc;
-
-}
-
-/*
-loop_
-_chem_comp_angle.comp_id
-_chem_comp_angle.atom_id_1
-_chem_comp_angle.atom_id_2
-_chem_comp_angle.atom_id_3
-_chem_comp_angle.value_angle
-_chem_comp_angle.value_angle_esd
- ATP      O2A    PA     O1A     119.900    3.000
-*/
-
-
-void CCP4SRSAngle::makeCIFTags ( PCMMCIFLoop mmCIFLoop )  {
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID         );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_3       );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE     );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE_ESD );
-}
-
-void CCP4SRSAngle::writeToCIF ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                            CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-  mmCIFLoop->AddString ( monID,False );
-  add_atom_to_cif ( mmCIFLoop,atom_1,atoms );
-  add_atom_to_cif ( mmCIFLoop,atom_2,atoms );
-  add_atom_to_cif ( mmCIFLoop,atom_3,atoms );
-  mmCIFLoop->AddReal ( angle    ,"%10.3f" );
-  mmCIFLoop->AddReal ( angle_esd,"%10.3f" );
-}
-
-void  CCP4SRSAngle::copy ( PCCP4SRSAngle ang, ivector anmatch )  {
-  if (anmatch)  {
-    atom_1 = anmatch[ang->atom1()];
-    atom_2 = anmatch[ang->atom2()];
-    atom_3 = anmatch[ang->atom3()];
-  } else  {
-    atom_1 = ang->atom1();
-    atom_2 = ang->atom2();
-    atom_3 = ang->atom3();
-  }
-  angle     = ang->value();
-  angle_esd = ang->esd  ();
-}
-
-
-void  CCP4SRSAngle::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-  memIO->put_integer ( atom_1    );
-  memIO->put_integer ( atom_2    );
-  memIO->put_integer ( atom_3    );
-  memIO->put_float   ( angle     );
-  memIO->put_float   ( angle_esd );
-}
-
-Boolean CCP4SRSAngle::read_mem ( PCMemIO memIO, int version,
-                                 Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-Boolean success;
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_integer ( atom_1   ,&success );
-  memIO->get_integer ( atom_2   ,&success );
-  memIO->get_integer ( atom_3   ,&success );
-  memIO->get_float   ( angle    ,&success );
-  memIO->get_float   ( angle_esd,&success );
-  if (Ok)  *Ok = success;
-  return success;
-}
+namespace ccp4srs  {
 
+  Angle::Angle()  {
+    atom_1    = -1;
+    atom_2    = -1;
+    atom_3    = -1;
+    angle     = 0.0;
+    angle_esd = 0.0;
+  }
+
+  Angle::~Angle()  {
+  }
+
+
+  int Angle::readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop, int angleNo,
+                           Container<Atom> & atoms )  {
+  int rc;
+
+    rc = 0;
+
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        angleNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        angleNo,atoms,rc );
+    get_atom_from_cif ( atom_3,mmCIFLoop,MMCIF_TAG_ATOM_ID_3,
+                        angleNo,atoms,rc );
+
+    mmCIFLoop->CopyReal(angle    ,MMCIF_TAG_VALUE_ANGLE    ,angleNo,rc);
+    mmCIFLoop->CopyReal(angle_esd,MMCIF_TAG_VALUE_ANGLE_ESD,angleNo,rc);
+
+    return rc;
+
+  }
+
+  /*
+  loop_
+  _chem_comp_angle.comp_id
+  _chem_comp_angle.atom_id_1
+  _chem_comp_angle.atom_id_2
+  _chem_comp_angle.atom_id_3
+  _chem_comp_angle.value_angle
+  _chem_comp_angle.value_angle_esd
+   ATP      O2A    PA     O1A     119.900    3.000
+  */
+
+
+  void Angle::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID         );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_3       );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE     );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VALUE_ANGLE_ESD );
+  }
+
+  void Angle::writeToCIF ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                              Container<Atom> & atoms )  {
+    mmCIFLoop->AddString ( monID,false );
+    add_atom_to_cif ( mmCIFLoop,atom_1,atoms );
+    add_atom_to_cif ( mmCIFLoop,atom_2,atoms );
+    add_atom_to_cif ( mmCIFLoop,atom_3,atoms );
+    mmCIFLoop->AddReal ( angle    ,"%10.3f" );
+    mmCIFLoop->AddReal ( angle_esd,"%10.3f" );
+  }
+
+  void  Angle::copy ( PAngle ang, mmdb::ivector anmatch )  {
+    if (anmatch)  {
+      atom_1 = anmatch[ang->atom1()];
+      atom_2 = anmatch[ang->atom2()];
+      atom_3 = anmatch[ang->atom3()];
+    } else  {
+      atom_1 = ang->atom1();
+      atom_2 = ang->atom2();
+      atom_3 = ang->atom3();
+    }
+    angle     = ang->value();
+    angle_esd = ang->esd  ();
+  }
+
+
+  void  Angle::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+    memIO->put_integer ( atom_1    );
+    memIO->put_integer ( atom_2    );
+    memIO->put_integer ( atom_3    );
+    memIO->put_float   ( angle     );
+    memIO->put_float   ( angle_esd );
+  }
+
+  bool Angle::read_mem ( PMemIO memIO, int version, bool * Ok ) {
+  UNUSED_ARGUMENT(version);
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_integer ( atom_1   ,&success );
+    memIO->get_integer ( atom_2   ,&success );
+    memIO->get_integer ( atom_3   ,&success );
+    memIO->get_float   ( angle    ,&success );
+    memIO->get_float   ( angle_esd,&success );
+    if (Ok)  *Ok = success;
+    return success;
+  }
+
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_angle.h ccp4srs/ccp4srs/ccp4srs_angle.h
--- ccp4srs-old/ccp4srs/ccp4srs_angle.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_angle.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_angle.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_angle.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_angle  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSAngle  - angle restraint class
+//  **** Classes :  ccp4srs::Angle  - angle restraint class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
@@ -41,39 +41,43 @@
 
 #include "ccp4srs_atom.h"
 
-DefineClass(CCP4SRSAngle)
+namespace ccp4srs  {
 
-class CCP4SRSAngle  {
+  DefineClass(Angle);
 
-  public:
-    CCP4SRSAngle();
-    virtual ~CCP4SRSAngle();
-
-    inline int      atom1() { return atom_1;    }
-    inline int      atom2() { return atom_2;    }
-    inline int      atom3() { return atom_3;    }
-    inline realtype value() { return angle;     }
-    inline realtype esd  () { return angle_esd; }
-
-    static void makeCIFTags ( PCMMCIFLoop mmCIFLoop );
-    int  readFromCIF ( PCMMCIFLoop mmCIFLoop, int angleNo,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    void writeToCIF  ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-
-    void    write_mem ( PCMemIO memIO, int version );
-    Boolean read_mem  ( PCMemIO memIO, int version,
-                        Boolean * Ok = NULL );
-
-    void copy ( PCCP4SRSAngle ang, ivector anmatch=NULL );
-
-  protected:
-    int      atom_1,atom_2,atom_3; // ordinal numbers of of atoms
-                                   //   that form the angle [0,1,...]
-    realtype angle;                // angle in degrees
-    realtype angle_esd;            // angle esd in degrees; set to 0.0
-                                   // if not provided
+  class Angle  {
 
-};
+    public:
+      Angle();
+      virtual ~Angle();
+
+      inline int            atom1() { return atom_1;    }
+      inline int            atom2() { return atom_2;    }
+      inline int            atom3() { return atom_3;    }
+      inline mmdb::realtype value() { return angle;     }
+      inline mmdb::realtype esd  () { return angle_esd; }
+
+      static void makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop );
+      int  readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop, int angleNo,
+                         Container<Atom> & atoms );
+      void writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                         Container<Atom> & atoms );
+
+      void write_mem ( PMemIO memIO, int version );
+      bool read_mem  ( PMemIO memIO, int version,
+                          bool * Ok = NULL );
+
+      void copy ( PAngle ang, mmdb::ivector anmatch=NULL );
+
+    protected:
+      int  atom_1,atom_2,atom_3; // ordinal numbers of of atoms
+                                 //   that form the angle [0,1,...]
+      mmdb::realtype angle;      // angle in degrees
+      mmdb::realtype angle_esd;  // angle esd in degrees; set to 0.0
+                                 // if not provided
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_ANGLE_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_atom.cpp ccp4srs/ccp4srs/ccp4srs_atom.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_atom.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_atom.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_atom.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_atom.cpp $
 //  =================================================================
 //
-//   CCP4 SRS Library: Storage, Retrievak and Search support for
+//   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
